

/////////////////////////////////////////////////////////////////////
// Mapper 16
class NES_mapper16 : public NES_mapper
{
  friend void adopt_MPRD(SnssMapperBlock* block, NES* nes);
  friend int extract_MPRD(SnssMapperBlock* block, NES* nes);

public:
  NES_mapper16(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper16() {}

  void  Reset();
  void  MemoryWriteSaveRAM(uint32 addr, uint8 data);
  void  MemoryWrite(uint32 addr, uint8 data);
  void  MemoryReadSaveRAM(uint32 addr);
  void  HSync(uint32 scanline);
  void  SetBarcodeValue(uint32 value_low, uint32 value_high);

protected:
  void  MemoryWrite2(uint32 addr, uint8 data);
  void  MemoryWrite3(uint32 addr, uint8 data);

  uint8 patch;
  uint8 regs[3];

  uint8 serial_out[0x2000];

  uint8 eeprom_cmd[4];
  uint8 eeprom_status;
  uint8 eeprom_mode;
  uint8 eeprom_pset;
  uint8 eeprom_addr, eeprom_data;
  uint8 eeprom_wbit, eeprom_rbit;

  uint8 barcode[256];
  uint8 barcode_status;
  uint8 barcode_pt;
  uint8 barcode_pt_max;
  uint8 barcode_phase;
  uint32 barcode_wait;
  uint8 barcode_enabled;

  uint8 irq_enabled;
  uint32 irq_counter;
  uint32 irq_latch;

private:
};
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Mapper 66
class NES_mapper66 : public NES_mapper
{
  friend void adopt_MPRD(SnssMapperBlock* block, NES* nes);
  friend int extract_MPRD(SnssMapperBlock* block, NES* nes);

public:
  NES_mapper66(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper66() {}

  void  Reset();

  void  MemoryWriteSaveRAM(uint32 addr, uint8 data);
  void  MemoryWrite(uint32 addr, uint8 data);

protected:
private:
};
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Mapper 70
class NES_mapper70 : public NES_mapper
{
  friend void adopt_MPRD(SnssMapperBlock* block, NES* nes);
  friend int extract_MPRD(SnssMapperBlock* block, NES* nes);

public:
  NES_mapper70(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper70() {}

  void  Reset();

  void  MemoryWrite(uint32 addr, uint8 data);

protected:
  uint8 patch;

private:
};
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Mapper 96
class NES_mapper96 : public NES_mapper
{
  friend void adopt_MPRD(SnssMapperBlock* block, NES* nes);
  friend int extract_MPRD(SnssMapperBlock* block, NES* nes);

public:
  NES_mapper96(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper96() {}

  void  Reset();
  void  MemoryWrite(uint32 addr, uint8 data);
  void  PPU_Latch_Address(uint32 addr);

protected:
  void  sync_PPU_banks();
  uint8 vbank0,vbank1;
  uint8 vram[0x8000];

private:
};
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Mapper 188
class NES_mapper188 : public NES_mapper
{
public:
  NES_mapper188(NES* parent) : NES_mapper(parent) {}
  ~NES_mapper188() {}

  void  Reset();
  void  MemoryWrite(uint32 addr, uint8 data);

protected:
  uint8 dummy[0x2000];

private:
};
/////////////////////////////////////////////////////////////////////

