#ifdef _NES_MAPPER_CPP_

/////////////////////////////////////////////////////////////////////
// Mapper 99
void NES_mapper99::Reset()
{
  // set CPU bank pointers
  if(num_8k_ROM_banks > 2)
  {
    set_CPU_banks(0,1,2,3);
  }
  else if(num_8k_ROM_banks > 1)
  {
    set_CPU_banks(0,1,0,1);
  }
  else
  {
    set_CPU_banks(0,0,0,0);
  }

  // set VROM bank
  if(num_1k_VROM_banks)
  {
    set_PPU_banks(0,1,2,3,4,5,6,7);
  }
}

void NES_mapper99::WriteHighRegs(uint32 addr, uint8 data)
{
  if(addr == 0x4016)
  {
    if(data & 0x04)
    {
      set_PPU_banks(8,9,10,11,12,13,14,15);
    }
    else
    {
      set_PPU_banks(0,1,2,3,4,5,6,7);
    }
  }
}
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Mapper 151
void NES_mapper151::Reset()
{
  // set CPU bank pointers
  set_CPU_banks(0,1,num_8k_ROM_banks-2,num_8k_ROM_banks-1);

  // set VROM banks
  set_PPU_banks(0,1,2,3,4,5,6,7);
}

void NES_mapper151::MemoryWrite(uint32 addr, uint8 data)
{
  switch(addr & 0xF000)
  {
    case 0x8000:
      {
        set_CPU_bank4(data);
      }
      break;

    case 0xA000:
      {
        set_CPU_bank5(data);
      }
      break;

    case 0xC000:
      {
        set_CPU_bank6(data);
      }
      break;

    case 0xE000:
      {
        set_PPU_bank0(data*4+0);
        set_PPU_bank1(data*4+1);
        set_PPU_bank2(data*4+2);
        set_PPU_bank3(data*4+3);
      }
      break;

    case 0xF000:
      {
        set_PPU_bank4(data*4+0);
        set_PPU_bank5(data*4+1);
        set_PPU_bank6(data*4+2);
        set_PPU_bank7(data*4+3);
      }
      break;
  }
}
/////////////////////////////////////////////////////////////////////

#endif
